// Nice code! John. Complete it! It should be a nice demo.

// Your mistakes were very common when starting with FiveWin. You should
// take care not redefining twice the same ID number -we are thinking
// about automatically controlling that from inside FiveWin- and not using
// a logical VAR with a GET control -logical only with CHECKBOXES-

// Go ahead with it!         Antonio

/* Program Ŀ
    Application: WinDesk Desktop Organizer!                                 
      File Name: WINDESK.PRG                                                
         Author: John H. Stolte, Sr.                                        
   Date created: 11-28-93                                                   
   Time created: 06:32:40pm                                                 
      Make File:                                                            
      Exec File:                                                            
      Copyright: 1993 by John H. Stolte, Sr.                                
  */
#include "FiveWin.ch"

static oWnd

//----------------------------------------------------------------------------//

function Main()

  local oBrush   //, oBar
  local hBorland := LoadLibrary( "BWCC.dll" )    // Take care! You are using
                                                 // Borlands Buttons in your
                                                 // dialogs so you will need
                                                 // this DLL

  SET RESOURCES TO "WINDESK.DLL"                 // identify the DLL

  DEFINE BRUSH oBrush STYLE BRICKS               // set the background wallpaper

  DEFINE WINDOW oWnd FROM 1, 5 TO 20, 75 ;       // define the main window
  TITLE "WinDesk Desktop Organizer" ;            // give it a caption
  BRUSH oBrush ;                                 // put the wallpaper on
  MENU  BuildMenu()                              // do the menu

//  @ 3, 2 BITMAP FILENAME "Logo.bmp" SIZE 982, 595 OF oWnd // logo

  SET MESSAGE OF oWnd ;
  TO "WinDesk Desktop Organizer"                 // msg at bottom

  ACTIVATE WINDOW oWnd MAXIMIZED                 // run the hummer!

  SET RESOURCES TO                               // clear the DLL

  FreeLibrary( hBorland )

return                                           // outahere

//----------------------------------------------------------------------------//

/* Function Ŀ
       Function: BuildMenu()                                                
    Description: umm...  Builds the menu                                    
  Ĵ
      Arguments: None                                                       
   Return Value: The menu object oMenu                                      
       See Also:                                                            
  */
function BuildMenu()

  local oMenu                                    // the menu object

  MENU oMenu                                     // top level menu bar
    MENUITEM "&DeskTop"                            
    MENU                                                     
      MENUITEM "&Rolodex" ;                                         
      MESSAGE "Edit Data in The Rolodex" ;
      ACTION Rolodex()                                             

      MENUITEM "&Calculator" ;                                      
      MESSAGE "Popup Calculator" ;
      ACTION Winexec("calc")                                       

      MENUITEM "Calen&dar" ;                                        
      MESSAGE "Popup Calendar" ;
      ACTION Winexec("Calendar")                                   

      MENUITEM "&NotePad" ;                                         
      MESSAGE "Popup Note Pad" ;
      ACTION Winexec("NotePad")                                    

      MENUITEM "&Write" ;                                           
      MESSAGE "Write - WordProcessor" ;
      ACTION Winexec("Write")                                      
    SEPARATOR                                               
      MENUITEM "&Close..." MESSAGE "Exit this Program" ACTION Exit() 
    ENDMENU

    MENUITEM "&Games"                              
    MENU
      MENUITEM "&Solitaire" ;                       
      MESSAGE "Play Solitaire when you have nothing else to do" ;
      ACTION Winexec("Sol")                         
    ENDMENU

    MENUITEM "&About..."
    MENU
      MENUITEM "About..." ;
      MESSAGE "My First Windows Database. (C) 1993 John H. Stolte, Sr." ;
      ACTION About()
    ENDMENU

  ENDMENU

return oMenu

//----------------------------------------------------------------------------//

/* Function Ŀ
       Function: Rolodex()                                                  
    Description: A simple Phone Book                                        
  Ĵ
      Arguments: None                                                       
   Return Value: Nil                                                        
       See Also:                                                            
  */
function Rolodex()
  local oDlg
  local oLname, oFname, oCompany, oAddress, oCity, oState, oZipcode, oPhone1, oPhone2, oPhone3, oActive, oNotes, oRecno
  local cLname, cFname, cCompany, cAddress, cCity, cState, cZipcode, cPhone1, cPhone2, cPhone3, lActive, mNotes
  local aStates :=  { "Alabama", "Alaska", "Arizona", "Arkansas", ;
  "California", "Colorado", "Connecticut", "Delaware", ;
  "District of Columbia", "Florida", "Georgia", "Hawaii", ;
  "Idaho", "Illinois", "Indiana", "Iowa", "Kansas", ;
  "Kentucky", "Louisiana", "Maine", "Maryland", ;
  "Massachusetts", "Michigan", "Minnesota", "Mississippi", ;
  "Missouri", "Montana", "Nebraska", "Nevada", ;
  "New Hampshire", "New Jersey", "New Mexico", "New York", ;
  "North Carolina", "North Dakota", "Ohio", "Oklahoma", ;
  "Oregon", "Pennsylvania", "Rhode Island", ;
  "South Carolina", "South Dakota", "Tennessee", "Texas", ;
  "Utah", "Vermont", "Virginia", "Washington", ;
  "West Virginia", "Wisconsin", "Wyoming", ;
  "American Samoa",  "Federated Micronesia", ;
  "Guam", "Mariana Islands", ;
  "Marshall Islands", "Palau Islands", "Puerto Rico", ;
  "Virgin Islands", "Alberta", ;
  "British Columbia", "Manitoba", "New Brunswick", ;
  "Newfoundland", "Northwest Territories", "Nova Scotia", ;
  "Ontario", "Prince Edward Island", "Quebec", ;
  "Saskatchewan", "Yukon" }

  USE ROLODEX NEW                                // no indexes yet

  cLNAME      := ROLODEX->LNAME
  cFNAME      := ROLODEX->FNAME
  cCOMPANY    := ROLODEX->COMPANY
  cADDRESS    := ROLODEX->ADDRESS
  cCITY       := ROLODEX->CITY
  cSTATE      := ROLODEX->STATE
  cZIPCODE    := ROLODEX->ZIPCODE
  cPHONE1     := ROLODEX->PHONE1
  cPHONE2     := ROLODEX->PHONE2

  // cPHONE2     := ROLODEX->PHONE2    <<<===== Error! This should be cPhone3 !
  cPhone3     := Rolodex->Phone3

  lActive     := ROLODEX->ACTIVE
  mNotes      := StrTran( ROLODEX->NOTES, Chr( 141 ) + Chr( 10 ), "" )
  lIsDel      := iif(deleted(),.t. ,.f. )

  DEFINE DIALOG oDlg RESOURCE "ROLODEX"          // get the dialog from the dll

  REDEFINE SAY ID 10 OF oDlg
  REDEFINE SAY ID 12 OF oDlg
  REDEFINE SAY ID 13 OF oDlg
  REDEFINE SAY ID 20 OF oDlg
  REDEFINE SAY ID 30 OF oDlg
  REDEFINE SAY ID 40 OF oDlg
  REDEFINE SAY ID 50 OF oDlg
  REDEFINE SAY ID 60 OF oDlg
  REDEFINE SAY ID 70 OF oDlg
  REDEFINE SAY ID 80 OF oDlg
  REDEFINE SAY ID 90 OF oDlg
  REDEFINE SAY ID 100 OF oDlg
  REDEFINE SAY ID 105 OF oDlg

  // REDEFINE SAY ID 110 OF oDlg         <<<==== Error! ID 110 used twice !
                                          // in the next !

  REDEFINE SAY oRecNo PROMPT Str( RecNo(), 5 ) ; // Here we trap a reference
  ID 110 OF oDlg                                 // to the SAY Object

  REDEFINE GET oLname    VAR cLName      ID 200 OF oDlg
  REDEFINE GET oFname    VAR cFname      ID 210 OF oDlg
  REDEFINE GET oCompnay  VAR cCompany    ID 220 OF oDlg
  REDEFINE GET oAddress  VAR cAddress    ID 230 OF oDlg
  REDEFINE GET oCity     VAR cCity       ID 240 OF oDlg
  REDEFINE GET oZipcode  VAR cZipcode    ID 260 OF oDlg
  REDEFINE GET oPhone1   VAR cPhone1     ID 270 OF oDlg
  REDEFINE GET oPhone2   VAR cPhone2     ID 280 OF oDlg
  REDEFINE GET oPhone3   VAR cPhone3     ID 290 OF oDlg

  // REDEFINE GET oActive   VAR lActive     ID 300 OF oDlg
  // Error !!!!!!   lActive should be a CHECKBOX and it is already some
  // lines down !!!   You are using twice the same identifier !

  REDEFINE GET oNotes    VAR mNotes MEMO ID 310 OF oDlg

  REDEFINE COMBOBOX oState VAR cState ITEMS aStates ID 250 OF oDlg // the combobox for states

  REDEFINE CHECKBOX oActive VAR lActive ID 300 OF oDlg

  REDEFINE BUTTON ID 400 OF oDlg ACTION MsgStop( "Not Yet Implemented", "Add" )
  REDEFINE BUTTON ID 410 OF oDlg ACTION MsgStop( "Not Yet Implemented", "Edit" )
  REDEFINE BUTTON ID 420 OF oDlg ACTION MsgStop( "Not Yet Implemented", "Delete" )
  REDEFINE BUTTON ID 430 OF oDlg ACTION MsgStop( "Not Yet Implemented", "Seek" )
  REDEFINE BUTTON ID 440 OF oDlg ACTION MsgStop( "Not Yet Implemented", "Print" )
  REDEFINE BUTTON ID 445 OF oDlg ACTION MsgStop( "Not Yet Implemented", "Save" )
  REDEFINE BUTTON ID 450 OF oDlg ACTION oDlg:End() // Quit Button

  ACTIVATE DIALOG oDlg CENTERED                  // Run the Hummer!

  USE                                            // Close the data

RETURN NIL


FUNCTION DoneBeep                                // Make some noise
  TONE(300, 1)
  TONE(100, 1)
  TONE(300, 1)
  TONE(100, 1)
RETURN NIL

//----------------------------------------------------------------------------//

function About()                                 // AboutBox

  local oDlg
  local cAuthors := OemToAnsi( "(c) John H. Stolte, Sr." )

  DEFINE DIALOG oDlg RESOURCE "About"

  REDEFINE SAY ID 10 OF oDlg
  REDEFINE SAY ID 20 OF oDlg
  REDEFINE SAY ID 30 OF oDlg
  REDEFINE SAY ID 40 OF oDlg

  ACTIVATE DIALOG oDlg CENTERED

return

//----------------------------------------------------------------------------//

function Exit()                                  // Quit

  local oDlg

  DEFINE DIALOG oDlg RESOURCE "Exit"

  REDEFINE SAY ID 10 OF oDlg
  REDEFINE BITMAP ID 110 OF oDlg RESOURCE "Question"

  ACTIVATE DIALOG oDlg CENTERED

  if oDlg:nResult == 1                           // IDOK
    oWnd:End()
  endif

return


//----------------------------------------------------------------------------//

