#include "FiveWin.ch"

static oWnd
static cIncPath, cLibPath

//----------------------------------------------------------------------------//

function Main()

   local oBrush, oIco, oBar
   local hBorland := LoadLibrary( "..\dll\BWCC.dll" )

   SET RESOURCES TO "Ide.dll"
   SET 3DLOOK ON

   IdeInit()

   DEFINE BRUSH oBrush STYLE TILED

   DEFINE ICON oIco FILE "..\icons\FW.ico"

   DEFINE WINDOW oWnd FROM 0, 0 TO 23, 78 ;
      TITLE "FiveWin 1.5 - IDE" ;
      BRUSH oBrush ;
      ICON  oIco ;
      MDI ;
      MENU BuildMenu()
      
   DEFINE BUTTONBAR oBar OF oWnd

   DEFINE BUTTON FILE "..\bitmaps\OpenPrj.bmp", "Exit.bmp" OF oBar ;
      MESSAGE "Open a new file" ACTION PrgOpen()

   DEFINE BUTTON FILE "..\bitmaps\ToDisk.bmp" OF oBar ;
      MESSAGE "Save to disk" ACTION MsgInfo( "Save" )

   DEFINE BUTTON FILE "..\bitmaps\Exit.bmp" OF oBar ;
      ACTION Exit() MESSAGE "Exit from IDE"

   DEFINE BUTTON FILE "..\bitmaps\Cut.bmp" OF oBar GROUP ;
      MESSAGE "Cut to Clipboard" ACTION MsgInfo( "Cut" )

   DEFINE BUTTON FILE "..\bitmaps\Copy.bmp" OF oBar ;
      MESSAGE "Copy to Clipboard" ACTION MsgInfo( "Copy" )

   DEFINE BUTTON FILE "..\bitmaps\Paste.bmp" OF oBar ;
      MESSAGE "Paste from Clipboard" ACTION MsgInfo( "Paste" )

   DEFINE BUTTON FILE "..\bitmaps\printer.bmp" OF oBar ;
      MESSAGE "Generates a printout"

   SET MESSAGE OF oWnd ;
      TO OemToAnsi( "FiveWin 1.2 - (c) A.Linares & F.Pulpon" )

   ACTIVATE WINDOW oWnd MAXIMIZED

   SET RESOURCES TO

   FreeLibrary( hBorland )

return

//----------------------------------------------------------------------------//

function BuildMenu()

   local oMenu

   MENU oMenu
      MENUITEM "&Program"
      MENU
        MENUITEM "&New..."   ACTION PrgNew()
        MENUITEM "&Open..."  ACTION PrgOpen()
        SEPARATOR
        MENUITEM "&Exit..."  ACTION Exit() MESSAGE "Finishing with FiveWin IDE"
      ENDMENU

      MENUITEM "&DataBases"
      MENU
         MENUITEM "&Use DBF..." ACTION DbfUse()
         MENUITEM "&New DBF..."
         MENUITEM "&WorkAreas..."
         SEPARATOR
         MENUITEM "Use I&ndex..."
         MENUITEM "New &Index..."
         SEPARATOR
         MENUITEM "&Relations..."
         MENUITEM "&Filters..."
         MENUITEM "R&DDs..."
      ENDMENU

      MENUITEM "&Resources"
      MENU
         MENUITEM "&Bitmaps"
         MENU
            MENUITEM "&New..."
            MENUITEM "&Open..." ACTION BmpOpen()
         ENDMENU
      ENDMENU

      MENUITEM "&Windows"
      MENU
         MENUITEM "&Arrange Icons..."   ACTION oWnd:ArrangeIcons()
         MENUITEM "&Tile Windows..."    ACTION oWnd:Tile()
         MENUITEM "&Cascade Windows..." ACTION oWnd:Cascade()
      ENDMENU

      MENUITEM "&Help"
      MENU
         MENUITEM "&About" ACTION DlgBox( "About" )
      ENDMENU
   ENDMENU

return oMenu

//----------------------------------------------------------------------------//

function PrgNew()

   local oWndEdit
   local cPrgName := "NONAM"
   local nStart   := 1

   while File( cPrgName := ( "NONAM" + SubStr( Str( nStart + 100, 3 ), 2 ) ;
                             + ".prg" ) )
      nStart++
   end

   DEFINE WINDOW oWndEdit EDIT FROM 1, 2 TO 12, 38 ;
      TITLE cPrgName OF oWnd

   ACTIVATE WINDOW oWndEdit

return

//----------------------------------------------------------------------------//

function PrgOpen()

   local oWndEdit
   local cPrgName := cGetFile( "*.prg", "Select a PRG" )

   if ! Empty( cPrgName )
      DEFINE WINDOW oWndEdit EDIT FROM 1, 2 TO 12, 38 ;
         TITLE cPrgName OF oWnd

      ACTIVATE WINDOW oWndEdit
   endif

return

//----------------------------------------------------------------------------//

function BrwNew()

   local oWndBrw

   USE Clients

   DEFINE WINDOW oWndBrw BROWSE FROM 1, 2 TO 12, 38 ;
      TITLE "BROWSE" OF oWnd

   ACTIVATE WINDOW oWndBrw

return

//----------------------------------------------------------------------------//

function PrjNew()

   local oWndPrj

   DEFINE WINDOW oWndPrj PROJECT FROM 1, 2 TO 12, 38 ;
      TITLE "New Project" OF oWnd

   ACTIVATE WINDOW oWndPrj

return

//----------------------------------------------------------------------------//

function DbfUse()

   local cDbf := cGetFile( "*.dbf", "Select a DBF" )
   local oWndBrw

   if ! Empty( cDbf )

      USE ( cDbf ) NEW

      DEFINE WINDOW oWndBrw BROWSE FROM 1, 2 TO 12, 38 ;
         TITLE cDbf OF oWnd

      ACTIVATE WINDOW oWndBrw

   endif

return

//----------------------------------------------------------------------------//

function DlgBox( cDlgName )

   local oDlg

   DEFINE DIALOG oDlg RESOURCE cDlgName

   ACTIVATE DIALOG oDlg CENTERED

return

//----------------------------------------------------------------------------//

function IdeInit()

   local oIni

   INI oIni FILENAME "Ide.ini"
      GET cIncPath SECTION "Path" ENTRY "Include" OF oIni
      GET cLibPath SECTION "Path" ENTRY "Lib"     OF oIni
   ENDINI

return

//----------------------------------------------------------------------------//

function Exit()

   local oDlg
   local lEnd := .f.

   DEFINE DIALOG oDlg RESOURCE "Exit"

   REDEFINE SAY ID 10 OF oDlg

   REDEFINE BUTTON ID 6 OF oDlg ACTION ( lEnd := .t., oDlg:End() )
   REDEFINE BUTTON ID 7 OF oDlg ACTION oDlg:End()

   ACTIVATE DIALOG oDlg CENTERED

   if lEnd
      oWnd:End()
   endif

return

//----------------------------------------------------------------------------//

function BmpOpen()

   local cBmpFile := cGetFile( "*.bmp", "Select a BMP" )
   local oWndBmp

   if ! Empty( cBmpFile )

      DEFINE WINDOW oWndBmp BITMAP cBmpFile FROM 3, 5 TO 22, 50 OF oWnd
      ACTIVATE WINDOW oWndBmp

   endif

return

//----------------------------------------------------------------------------//
