#ifndef _WINDOW_CH
#define _WINDOW_CH

#xcommand DEFINE WINDOW <oWnd> ;
             [ FROM <nTop>, <nLeft> TO <nBottom>, <nRight> ] ;
             [ TITLE <cTitle> ] ;
             [ STYLE <nStyle> ] ;
             [ MENU  <oMenu> ] ;
             [ BRUSH <oBrush> ] ;
             [ ICON  <oIcon> ] ;
             [ MDI ] ;
       => ;
          <oWnd> := TMdiFrame():New( <nTop>, <nLeft>, <nBottom>, <nRight>,;
             <cTitle>, <nStyle>, <oMenu>, <oBrush>, <oIcon> )

#xcommand DEFINE WINDOW <oWnd> ;
             [ FROM <nTop>, <nLeft> TO <nBottom>, <nRight> ] ;
             [ TITLE <cTitle> ] ;
             [ EDIT ] ;
             [ OF <oParent> ] ;
       => ;
          <oWnd> := TMdiEdit():New( <nTop>, <nLeft>, <nBottom>, <nRight>,;
             <cTitle>, <oParent> )

#xcommand DEFINE WINDOW <oWnd> ;
             [ FROM <nTop>, <nLeft> TO <nBottom>, <nRight> ] ;
             [ TITLE <cTitle> ] ;
             [ MENU  <oMenu> ] ;
             [ BROWSE ] ;
             [ OF <oParent> ] ;
       => ;
          <oWnd> := TMdiBrowse():New( <nTop>, <nLeft>, <nBottom>, <nRight>,;
             <cTitle>, <oMenu>, <oParent> )

#xcommand DEFINE WINDOW <oWnd> ;
             [ FROM <nTop>, <nLeft> TO <nBottom>, <nRight> ] ;
             [ TITLE <cTitle> ] ;
             [ MENU  <oMenu> ] ;
             [ PROJECT ] ;
             [ OF <oParent> ] ;
       => ;
          <oWnd> := TMdiProjec():New( <nTop>, <nLeft>, <nBottom>, <nRight>,;
             <cTitle>, <oMenu>, <oParent> )

#xcommand DEFINE WINDOW <oWnd> ;
             [ FROM <nTop>, <nLeft> TO <nBottom>, <nRight> ] ;
             [ BITMAP <cBmpFile> ] ;
             [ OF <oParent> ] ;
       => ;
          <oWnd> := TMdiBmp():New( <nTop>, <nLeft>, <nBottom>, <nRight>,;
             <cBmpFile>, <oParent> )

#xcommand DEFINE WINDOW <oWnd> ;
             [ FROM <nTop>, <nLeft> TO <nBottom>, <nRight> ] ;
             [ TITLE <cTitle> ] ;
             [ STYLE <nStyle> ] ;
             [ MENU <oMenu> ] ;
             [ BRUSH <oBrush> ] ;
             [ ICON  <oIcon> ] ;
             [ OF <oParent> ] ;
       => ;
          <oWnd> := TWindow():New( <nTop>, <nLeft>, <nBottom>, <nRight>,;
             <cTitle>, <nStyle>, <oMenu>, <oBrush>, <oIcon>, <oParent> )

#xcommand ACTIVATE WINDOW <oWnd> ;
             [ <show: ICONIZED, NORMAL, MAXIMIZED> ] ;
             [ ON LEFT CLICK <uLClick> ] ;
             [ ON RIGHT CLICK <uRClick> ] ;
             [ ON MOVE <uMove> ] ;
             [ ON RESIZE <uResize> ] ;
             [ ON PAINT <uPaint> ] ;
             [ ON KEYDOWN <uKeyDown> ] ;
             [ ON INIT <uInit> ] ;
       => ;
          <oWnd>:Activate( [ Upper(<(show)>) ],;
                           <oWnd>:bLClicked [ := \{ |nRow,nCol,nKeyFlags| <uLClick> \} ], ;
                           <oWnd>:bRClicked [ := \{ |nRow,nCol,nKeyFlags| <uRClick> \} ], ;
                           <oWnd>:bMoved    [ := <{uMove}> ], ;
                           <oWnd>:bResized  [ := <{uResize}> ], ;
                           <oWnd>:bPainted  [ := <{uPaint}> ], ;
                           <oWnd>:bKeyDown  [ := \{ |nKey| <uKeyDown> \} ],;
                           <oWnd>:bInit     [ := \{ | Self | <uInit> \} ] )

#xcommand DEFINE BUTTONBAR [ <oBar> ] ;
             [ <wnd: OF, WINDOW, DIALOG> <oWnd> ] ;
      => ;
         [ <oBar> := ] TBar():New( <oWnd> )

#xcommand DEFINE BUTTON [ <oBtn> ] ;
             [ <bar: OF, BUTTONBAR > <oBar> ] ;
             [ <resource: NAME, RESNAME, RESOURCE> <cResName1> [,<cResName2>] ] ;
             [ <file: FILE, FILENAME, DISK> <cBmpFile1> [,<cBmpFile2>] ] ;
             [ ACTION <uAction> ] ;
             [ <group: GROUP > ] ;
             [ MESSAGE <cMsg> ] ;
      => ;
         [ <oBtn> := ] TBtnBmp():NewBar( <cResName1>, <cResName2>,;
                                         <cBmpFile1>, <cBmpFile2>,;
                                         <cMsg>, <{uAction}>, <.group.>,;
                                         <oBar> )
#endif
